unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, RomUnit, ShellAPI, ExtCtrls, Partition, MMSystem, Midi, MPlayer,
  Spin, ComCtrls, Buttons, TrackInfoUnit, Menus;

const WM_MOVECUR = WM_USER;
      WM_PLAY = WM_USER + 1;
      MOVECURSPEED = 8;

type
  TMidiCallbackFunc = procedure (handle: HMIDIOUT; uMsg: UINT; dwInstance: DWORD; dwParam1: DWORD; dwParam2: DWORD) of object;
  pMidiCallbackFunc = ^TMidiCallbackFunc;
  TMidiNote = class
    Note: byte;
    Pos: integer;
    Len: integer;
    Channel: byte;
    Track: byte;
  end;
  TMain = class(TForm)
    Partition: TPartition;
    TimerNoteOFF: TTimer;
    TrackList: TListView;
    AddTrack: TButton;
    ModTrack: TButton;
    DelTrack: TButton;
    PanelPlay: TPanel;
    BackBegin: TSpeedButton;
    Back2: TSpeedButton;
    Back1: TSpeedButton;
    Forw1: TSpeedButton;
    Forw2: TSpeedButton;
    ForwEnd: TSpeedButton;
    Play: TSpeedButton;
    StopPlay: TSpeedButton;
    PausePlay: TSpeedButton;
    PanelEditMode: TPanel;
    ModeSelect: TSpeedButton;
    ModeNote: TSpeedButton;
    ModeDieze: TSpeedButton;
    GridLess: TSpeedButton;
    GridPlus: TSpeedButton;
    GridSize: TLabel;
    Menu: TMainMenu;
    Fichier: TMenuItem;
    Nouveau: TMenuItem;
    Ouvrir: TMenuItem;
    Enregistrer: TMenuItem;
    SaveAs: TMenuItem;
    N1: TMenuItem;
    Quitter: TMenuItem;
    OpenDlg: TOpenDialog;
    SaveDlg: TSaveDialog;
    N2: TMenuItem;
    Deasm: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PartitionExtMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y, Pos, LargePos: Integer; NoteNum: Byte;
      Note: TPartitionNote);
    procedure TimerNoteOFFTimer(Sender: TObject);
    procedure PartitionExtMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y, Pos, LargePos: Integer; NoteNum: Byte; Note: TPartitionNote);
    procedure PartitionExtMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y, Pos, LargePos: Integer; NoteNum: Byte;
      Note: TPartitionNote);
    procedure AddTrackClick(Sender: TObject);
    procedure DelTrackClick(Sender: TObject);
    procedure ModTrackClick(Sender: TObject);
    procedure TrackListClick(Sender: TObject);
    procedure Back1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BackBeginClick(Sender: TObject);
    procedure ForwEndClick(Sender: TObject);
    procedure Back2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Forw1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Forw2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PlayClick(Sender: TObject);
    procedure StopPlayClick(Sender: TObject);
    procedure PausePlayClick(Sender: TObject);
    procedure GridLessClick(Sender: TObject);
    procedure GridPlusClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ModeNoteClick(Sender: TObject);
    procedure ModeDiezeClick(Sender: TObject);
    procedure QuitterClick(Sender: TObject);
    procedure NouveauClick(Sender: TObject);
    procedure EnregistrerClick(Sender: TObject);
    procedure SaveAsClick(Sender: TObject);
    procedure OuvrirClick(Sender: TObject);
    procedure DeasmClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    MidiOut: TMidiOutput;
    Sizing: boolean;
    Notes: TList; // Toutes les notes de tous les tracks...
    StopMoveCur: boolean;
    BtnMove: TSpeedButton;
    StopPlayNow, PausePlayNow: boolean;
    SelStart: TPoint;
    NoteSel: TPartitionNote;
    Modified: boolean;
    FileName: string;
    procedure DisassMidi(FName, OName: string);
    procedure MoveCur(Speed: integer);
    procedure DoMoveCur(var Message: TMessage); message WM_MOVECUR;
    procedure DoPlay(var Message: TMessage); message WM_PLAY;
    procedure PlayNote(Channel, Note: byte);
  end;

var
  Main: TMain;

implementation

{$R *.DFM}

procedure TMain.DisassMidi(FName, OName: string);
var F: TMemoryStream;
    O: textfile;
    s, ss: string;
    s2: array[1..2] of byte;
    s4: array[1..4] of byte;
    dt: Array8;
    b: byte;
    w: word;
    si: shortint;

    i, n, t: integer;
    TrackCnt: word;
  function tabed(str: string): string;
  begin
    result:=str;
    while length(result)<18 do result:=result+' ';
  end;
  function s2toword: word;
  var tamp: array[1..2] of byte;
  begin
    tamp[1]:=s2[2];
    tamp[2]:=s2[1];
    result:=word(tamp);
  end;
  function s4tocard: cardinal;
  var tamp: array[1..4] of byte;
  begin
    tamp[1]:=s4[4];
    tamp[2]:=s4[3];
    tamp[3]:=s4[2];
    tamp[4]:=s4[1];
    result:=cardinal(tamp);
  end;
  function dttocard: cardinal;
  var v: vlv;
  begin
    v:=vlv.create;
    v.SetFromVLVA8(dt);
    result:=v.CardVal;
    v.free;
  end;
begin
  // Ouverture du fichier MIDI en mmoire
  F:=TMemoryStream.Create;
  F.LoadFromFile(FName);

  // Dsassemblage
  assignfile(O, OName);
  rewrite(O);
  writeln(O, 'Disassembling of '+FName);
  writeln(O, 'By Mided');
  writeln(O);
  try
    // Header
    if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
    F.Read(s4, 4);
    if cardinal(s4)<>($6468544D) then begin writeln(O, 'Unexpected byte at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
{
    if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
    F.Read(b, 1);
    if b<>$54 then begin writeln(O, 'Unexpected byte at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;

    if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
    F.Read(b, 1);
    if b<>$68 then begin writeln(O, 'Unexpected byte at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;

    if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
    F.Read(b, 1);
    if b<>$64 then begin writeln(O, 'Unexpected byte at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
}
    s:=tabed('4D 54 68 64');
    writeln(O, 'File Header');
    writeln(O, '===========');
    writeln(O, s+'"MThd"');

    if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
    F.Read(b, 1);
    if b<>0 then begin writeln(O, 'Unexpected byte at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;

    if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
    F.Read(b, 1);
    if b<>0 then begin writeln(O, 'Unexpected byte at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;

    if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
    F.Read(b, 1);
    if b<>0 then begin writeln(O, 'Unexpected byte at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;

    if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
    F.Read(b, 1);
    if b<>6 then begin writeln(O, 'Unexpected byte at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;

    s:=tabed('00 00 00 06');
    writeln(O, s+'Size of header: 6');

    if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
    F.Read(b, 1);
    if b<>0 then begin writeln(O, 'Unexpected byte at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;

    if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
    F.Read(b, 1);
    if b=0 then
    begin
      s:=tabed('00 00');
      writeln(O, s+'File Format: single track');
    end else if b=1 then begin
      s:=tabed('00 01');
      writeln(O, s+'File Format: synchronous multiple tracks');
    end else if b=2 then begin
      s:=tabed('00 02');
      writeln(O, s+'File Format: asynchronous multiple tracks');
    end else begin writeln(O, 'Unexpected byte at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;

    if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
    F.Read(s2, 2);
    w:=s2toword;
    s:=tabed(IntToHex(s2[1], 2)+' '+IntToHex(s2[2], 2));
    writeln(O, s+'Number of tracks: '+inttostr(w));
    TrackCnt:=w;

    if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
    F.Read(s2, 2);
    w:=s2toword;
    s:=tabed(IntToHex(s2[1], 2)+' '+IntToHex(s2[2], 2));
    writeln(O, s+'Number of delta-time ticks per quarter note: '+inttostr(w));
    writeln(O);
    // End of Header

    // Tracks
    i:=0;
    while true do
    begin
      if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); break; end;

      // Track Header
      F.Read(s4, 4);
      if cardinal(s4)<>($6B72544D) then begin writeln(O, 'Unexpected byte at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;

      inc(i);
      if i>TrackCnt then begin writeln(O, 'Unexpected byte at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
      s:=tabed('4D 54 72 6B');
      writeln(O, 'Track '+inttostr(i));
      if i>9 then writeln(O, '========') else writeln(O, '=======');
      writeln(O, s+'"MTrk"');

      F.Read(s4, 4);
      s:=tabed(IntToHex(s4[1], 2)+' '+IntToHex(s4[2], 2)+' '+IntToHex(s4[3], 2)+' '+IntToHex(s4[4], 2));
      writeln(O, s+'Size of track: '+inttostr(s4tocard));
      writeln(O);
      // End of Header

      // Events
      while true do
      begin
        if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;

        // Delta-Time
        n:=0;
        while true do
        begin
          if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
          F.Read(b, 1);
          if n>=8 then
          begin
            writeln(O, 'Delta-Time is too long at offset #'+inttostr(F.Position));
            raise Exception.Create('');
          end;
          inc(n);
          dt[n]:=b;
          if b<128 then break;
        end;
        s:='';
        for t:=1 to n do s:=s+' '+IntToHex(dt[t], 2);
        s:=tabed(min(s));
        writeln(O, s+'Event Delta-Time: '+inttostr(dttocard));

        // Event kind
        if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
        F.Read(b, 1);
        if b=$FF then
        begin
          // Meta-Event
          if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
          F.Read(b, 1);
          if b=$03 then
          begin
            if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
            F.Read(b, 1);
            s:=tabed('FF 03 '+IntToHex(b, 2));
            writeln(O, s+'Track name (size: '+inttostr(b)+')');
            for t:=1 to (b div 6) do
            begin
              if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
              F.Read(dt, 6);
              s:=tabed(IntToHex(dt[1], 2)+' '+IntToHex(dt[2], 2)+' '+IntToHex(dt[3], 2)+' '+
                       IntToHex(dt[4], 2)+' '+IntToHex(dt[5], 2)+' '+IntToHex(dt[6], 2));
              writeln(O, s+'"'+chr(dt[1])+chr(dt[2])+chr(dt[3])+chr(dt[4])+chr(dt[5])+chr(dt[6])+'"');
            end;
            if (b mod 6)>0 then
            begin
              s:='';
              ss:='"';
              for t:=1 to (b mod 6) do
              begin
                if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
                F.Read(dt[1], 1);
                s:=s+' '+IntToHex(dt[1], 2);
                ss:=ss+chr(dt[1]);
              end;
              s:=tabed(min(s));
              ss:=ss+'"';
              writeln(O, s+ss);
            end;
            writeln(O);
          end else
          if b=$2F then
          begin
            if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
            F.Read(b, 1);
            if b=$00 then
            begin
              s:=tabed('FF 2F 00');
              writeln(O, s+'End of track');
              writeln(O);
              break;
            end else begin
              writeln(O, 'Unexpected parameter size at offset #'+inttostr(F.Position));
              raise Exception.Create('');
            end;
          end else
          if b=$58 then // Time Signature
          begin
            if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
            F.Read(b, 1);
            if b=$04 then
            begin
              s:=tabed('FF 58 04');
              writeln(O, s+'Time Signature event');

              if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
              F.Read(s2, 2);
              s:=tabed(IntToHex(s2[1], 2)+' '+IntToHex(s2[2], 2));
              writeln(O, s+'Signature: '+inttostr(s2[1])+' / '+inttostr(trunc(intpower(2, s2[2]))));

              if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
              F.Read(b, 1);
              s:=tabed(IntToHex(b, 2));
              writeln(O, s+'Number of ticks in metronome click: '+inttostr(b));

              if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
              F.Read(b, 1);
              s:=tabed(IntToHex(b, 2));
              writeln(O, s+'Number of 32nd notes to the quarter note: '+inttostr(b));
              writeln(O);
            end else begin
              writeln(O, 'Unexpected parameter size at offset #'+inttostr(F.Position));
              raise Exception.Create('');
            end;
          end else
          if b=$51 then
          begin
            if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
            F.Read(b, 1);
            if b=$03 then
            begin
              s:=tabed('FF 51 03');
              writeln(O, s+'Tempo setting');
              s4[1]:=0;
              F.Read(s4[2], 1);
              F.Read(s4[3], 1);
              F.Read(s4[4], 1);
              s:=tabed(IntToHex(s4[2], 2)+' '+IntToHex(s4[3], 2)+' '+IntToHex(s4[4], 2));
              writeln(O, s+'Tempo: '+inttostr(s4tocard));
              writeln(O);
            end else begin
              writeln(O, 'Unexpected parameter size at offset #'+inttostr(F.Position));
              raise Exception.Create('');
            end;
          end else
          if b=$59 then
          begin
            if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
            F.Read(b, 1);
            if b=$02 then
            begin
              s:=tabed('FF 59 02');
              writeln(O, s+'Key Signature');
              F.Read(si, 1);
              s:=tabed(IntToHex(si, 2));
              if si=-7 then writeln(O, s+'7 flats') else
              if si=0 then writeln(O, s+'Key of C') else
              if si=7 then writeln(O, s+'7 sharps') else
                writeln(O, s+'unknown');
              F.Read(b, 1);
              s:=tabed(IntToHex(b, 2));
              if b=1 then writeln(O, s+'Minor') else
              if b=0 then writeln(O, s+'Major') else
                writeln(O, s+'unknown');
              writeln(O);
            end else begin
              writeln(O, 'Unexpected parameter size at offset #'+inttostr(F.Position));
              raise Exception.Create('');
            end;
          end else
          begin
            writeln(O, 'Unknown meta-event at offset #'+inttostr(F.Position));
            raise Exception.Create('');
          end;
        end else begin
          // Normal Event
          if (b and 240)=$80 then
          begin
            s:=tabed(IntToHex(b, 2));
            writeln(O, s+'Note OFF on channel '+inttostr(b and 15));
            if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
            F.Read(s2, 2);
            s:=tabed(IntToHex(s2[1], 2)+' '+IntToHex(s2[2], 2));
            writeln(O, s+'Note: '+inttostr(s2[1])+'; Velocity: '+inttostr(s2[2]));
            writeln(O);
          end else if (b and 240)=$90 then begin
            s:=tabed(IntToHex(b, 2));
            writeln(O, s+'Note ON on channel '+inttostr(b and 15));
            if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
            F.Read(s2, 2);
            s:=tabed(IntToHex(s2[1], 2)+' '+IntToHex(s2[2], 2));
            writeln(O, s+'Note: '+inttostr(s2[1])+'; Velocity: '+inttostr(s2[2]));
            writeln(O);
          end else if (b and 240)=$B0 then begin
            s:=tabed(IntToHex(b, 2));
            writeln(O, s+'Controller change on channel '+inttostr(b and 15));
            if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
            F.Read(s2, 2);
            s:=tabed(IntToHex(s2[1], 2)+' '+IntToHex(s2[2], 2));
            writeln(O, s+'Controller: '+inttostr(s2[1])+'; New value: '+inttostr(s2[2]));
            writeln(O);
          end else if (b and 240)=$C0 then begin
            s:=tabed(IntToHex(b, 2));
            writeln(O, s+'Program change on channel '+inttostr(b and 15));
            if F.Position>=F.Size then begin writeln(O, 'Unexpected end of file at offset #'+inttostr(F.Position)); raise Exception.Create(''); end;
            F.Read(s2, 1);
            s:=tabed(IntToHex(s2[1], 1));
            writeln(O, s+'New program: '+inttostr(s2[1]));
            writeln(O);
          end else if (b and 240)=$F0 then begin
            s:=tabed(IntToHex(b, 2));
            writeln(O, s+'Unknown event, guessed size, channel (if used) is '+inttostr(b and 15));
            F.Read(dt, 6);
            s:=tabed(IntToHex(dt[1], 2)+' '+IntToHex(dt[2], 2)+' '+IntToHex(dt[3], 2)+' '+
                     IntToHex(dt[4], 2)+' '+IntToHex(dt[5], 2)+' '+IntToHex(dt[6], 2));
            writeln(O, s+'unknown');
            F.Read(dt, 5);
            s:=tabed(IntToHex(dt[1], 2)+' '+IntToHex(dt[2], 2)+' '+IntToHex(dt[3], 2)+' '+
                     IntToHex(dt[4], 2)+' '+IntToHex(dt[5], 2));
            writeln(O, s+'unknown');
            writeln(O);
          end else begin
            writeln(O, 'Unknown event at offset #'+inttostr(F.Position));
            raise Exception.Create('');
          end;
        end;
      end;

      if i=TrackCnt then
      begin
        writeln(O, '* Logical End *');
        if F.Position>=F.Size then writeln(O, '* End Of File *')
                              else writeln(O, 'Unexpected byte after logical end at offset #'+inttostr(F.Position));
        break;
      end;
    end;
  except
  end;
  closefile(O);
  F.Free;
end;

procedure TMain.FormCreate(Sender: TObject);
begin
  MidiOut:=TMidiOutput.Create(0, true);
  Notes:=TList.Create;
  Sizing:=false;
  StopMoveCur:=true;
  TrackList.Width:=ClientWidth-16;
  TrackList.Height:=ClientHeight-8-TrackList.Top;
  Partition.Width:=ClientWidth-16;
  NoteSel:=nil;
  Modified:=false;
  FileName:='';
end;

procedure TMain.FormClose(Sender: TObject; var Action: TCloseAction);
var i: integer;
begin
  MidiOut.Free;
  PausePlayNow:=true;
  for i:=0 to Notes.Count-1 do
    TMidiNote(Notes[i]).Free;
  Notes.Free;
end;

procedure TMain.PartitionExtMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y, Pos, LargePos: Integer;
  NoteNum: Byte; Note: TPartitionNote);
begin
  if TrackList.Selected<>nil then
  begin
    if (Button = mbLeft) then
    begin
      if ModeSelect.Down then
      begin
        // PlayNote(strtoint(TrackList.Selected.SubItems[1]), NoteNum);
        if Note=nil then
        begin
          SelStart.X:=X;
          SelStart.Y:=Y;
        end else begin
          SelStart.X:=-1;
          Note.Sel:=true;
          Partition.Paint;
          NoteSel:=Note;
        end;
      end else
      if ModeNote.Down then
      begin
        PlayNote(strtoint(TrackList.Selected.SubItems[1]), NoteNum);

        // Note dans la liste globale
        Notes.Add(TMidiNote.Create);
        with TMidiNote(Notes[Notes.Count-1]) do
        begin
          Note:=NoteNum;
          Len:=Partition.LargePosLen-Partition.LargePosLen div 4;
          Pos:=LargePos;
          Channel:=StrToInt(TrackList.Selected.SubItems[1]);
          Track:=StrToInt(TrackList.Selected.Caption);
        end;

        // Note dans la partition
        Partition.AddNote(NoteNum, LargePos, Partition.LargePosLen-Partition.LargePosLen div 4, integer(Notes[Notes.Count-1]));
        Sizing:=true;
      end else
      if ModeDieze.Down then
      begin
        if Note<>nil then
        begin
          PlayNote(strtoint(TrackList.Selected.SubItems[1]), Note.Note+1);
          Note.Note:=Note.Note+1;
          TMidiNote(Note.Tag).Note:=Note.Note;
          Partition.Paint;
        end;
      end;
    end else if Button = mbRight then
    begin
      if ModeNote.Down then
      begin
        if Note<>nil then
        begin
          TMidiNote(Notes[Notes.IndexOf(Pointer(Note.Tag))]).Free;
          Notes.Delete(Notes.IndexOf(Pointer(Note.Tag)));
          Partition.DeleteNote(Note);
        end;
      end else
      if ModeDieze.Down then
      begin
        if Note<>nil then
        begin
          PlayNote(strtoint(TrackList.Selected.SubItems[1]), Note.Note-1);
          Note.Note:=Note.Note-1;
          TMidiNote(Note.Tag).Note:=Note.Note;
          Partition.Paint;
        end;
      end;
    end;
  end else if Button = mbLeft then PlayNote(0, NoteNum);
  Modified:=true;
end;

procedure TMain.TimerNoteOFFTimer(Sender: TObject);
begin
  MidiOut.NoteOFF(Partition.Tag, TimerNoteOFF.Tag);
  TimerNoteOff.Enabled:=false;
end;

procedure TMain.PartitionExtMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y, Pos, LargePos: Integer; NoteNum: Byte; Note: TPartitionNote);
var PN: TPartitionNote;
    i: integer;
  function Lower(a, b: integer): integer;
  begin
    if a>b then result:=b else result:=a;
  end;
begin
  if Sizing and (ssLeft in Shift) then
  begin
    PN:=Partition.Notes[Partition.Notes.Count-1];
    if (Pos-PN.Pos)>0 then
    begin
      if ssShift in Shift then PN.Len:=(Pos-PN.Pos) div Partition.LargePosLen * Partition.LargePosLen else
      if ssCtrl in Shift then PN.Len:=(Pos-PN.Pos) div Partition.LargePosLen * Partition.LargePosLen - Lower(Partition.LargePosLen div 4, 4) else
      if ssAlt in Shift then PN.Len:=Lower(Partition.LargePosLen div 4, 4) else
        PN.Len:=Pos-PN.Pos;
      if PN.Len<1 then PN.Len:=1;
      TMidiNote(PN.Tag).Len:=PN.Len;
    end else begin
      TPartitionNote(PN).Len:=1;
      TMidiNote(PN.Tag).Len:=1;
    end;
    Partition.Paint;
  end else
  if ModeSelect.Down and (ssLeft in Shift) and (TrackList.Selected<>nil) and (SelStart.X>-1) then
  begin
    Partition.Paint;
    with Partition.Canvas do
    begin
      Brush.Style:=bsClear;
      Pen.Style:=psDot;
      Pen.Color:=clBlack;
      Rectangle(SelStart.X, SelStart.Y, X, Y);
      Brush.Style:=bsSolid;
      Pen.Style:=psSolid;
    end;
  end else
  if ModeSelect.Down and (ssLeft in Shift) and (TrackList.Selected<>nil) and (NoteSel<>nil) then
  begin
    // Dplacement de notes
    for i:=0 to Partition.Notes.Count-1 do
    begin
      PN:=Partition.Notes[i];
      if PN.Sel and (PN<>NoteSel) then
      begin
        PN.Pos:=PN.Pos+LargePos-NoteSel.Pos;
        TMidiNote(PN.Tag).Pos:=PN.Pos;
        PN.Note:=PN.Note+NoteNum-NoteSel.Note;
        TMidiNote(PN.Tag).Note:=PN.Note;
      end;
    end;
    NoteSel.Pos:=LargePos;
    TMidiNote(NoteSel.Tag).Pos:=NoteSel.Pos;
    NoteSel.Note:=NoteNum;
    TMidiNote(NoteSel.Tag).Note:=NoteSel.Note;
    Partition.Paint;

    if (X<=20) then Partition.FirstMesure:=Partition.FirstMesure-1;
    if (X>=Partition.Width-20) then Partition.FirstMesure:=Partition.FirstMesure+1;
  end;
end;

procedure TMain.PartitionExtMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y, Pos, LargePos: Integer; NoteNum: Byte;
  Note: TPartitionNote);
var i: integer;
    N: TPartitionNote;
    NR, SR, UR: TRect;
begin
  Sizing:=false;
  NoteSel:=nil;
  if ModeSelect.Down and (TrackList.Selected<>nil) and (SelStart.X>-1) then
  begin
    for i:=0 to Partition.Notes.Count-1 do
    begin
      N:=Partition.Notes[i];
      NR:=Rect((N.Pos - Partition.FirstPos) * Partition.SmallestWidth, N.Note-1, (N.Pos+N.Len-Partition.FirstPos) * Partition.SmallestWidth, N.Note+1);
      if (SelStart.X<=X) and (SelStart.Y<=Y) then SR:=Rect(SelStart.X, Partition.GetNote(Y), X, Partition.GetNote(SelStart.Y)) else
      if (SelStart.X>=X) and (SelStart.Y<=Y) then SR:=Rect(X, Partition.GetNote(Y), SelStart.X, Partition.GetNote(SelStart.Y)) else
      if (SelStart.X<=X) and (SelStart.Y>=Y) then SR:=Rect(SelStart.X, Partition.GetNote(SelStart.Y), X, Partition.GetNote(Y)) else
        SR:=Rect(X, Partition.GetNote(SelStart.Y), SelStart.X, Partition.GetNote(Y));
      N.Sel:=IntersectRect(UR, NR, SR);
    end;
    Partition.Paint;
  end;
end;

procedure TMain.AddTrackClick(Sender: TObject);
var i, n, c: integer;
    b: boolean;
begin
  c:=0;
  for i:=0 to 15 do
  begin
    b:=true;
    for n:=0 to TrackList.Items.Count-1 do
      if strtoint(TrackList.Items[n].SubItems[1])=i then b:=false;
    if b then
    begin
      c:=i;
      break;
    end;
  end;
  TrackInfo.TrackChannel.Value:=c;

  if TrackInfo.ShowModal = mrOK then
  begin
    // Vrifier que le Canal n'est pas dj utilis
    b:=true;
    c:=TrackInfo.TrackChannel.Value;
    n:=0;
    for i:=0 to TrackList.Items.Count-1 do
    begin
      if strtoint(TrackList.Items[i].SubItems[1])=c then
      begin
        n:=i;
        b:=false;
        break;
      end;
    end;

    // Ajouter le track
    if b then
    begin
      TrackList.Items.Add;
      with TrackList.Items[TrackList.Items.Count-1] do
      begin
        Caption:=inttostr(TrackList.Items.Count-1);
        SubItems.Add(TrackInfo.TrackName.Text);
        SubItems.Add(inttostr(TrackInfo.TrackChannel.Value));
        SubItems.Add(TrackInfo.TrackPatch.Text);
        Selected:=true;
      end;
      TrackListClick(Sender);
      TrackList.SetFocus;
      MidiOut.ChangePatch(TrackInfo.TrackChannel.Value, strtoint(mot(1, TrackInfo.TrackPatch.Text)));
    end else MessageDlg('Le canal '+inttostr(c)+' est dj utilis par le track #'+inttostr(n)+'.', mtError, [mbCancel], 0);
  end;
  AddTrack.Enabled:=TrackList.Items.Count<16;
  ModTrack.Enabled:=TrackList.Items.Count>0;
  DelTrack.Enabled:=TrackList.Items.Count>0;
  Modified:=true;
end;

procedure TMain.DelTrackClick(Sender: TObject);
var i, t: integer;
    N: TMidiNote;
begin
  if TrackList.Selected<>nil then
  begin
    if MessageDlg('Etes-vous sr(e) de vouloir supprimer le track slectionn?', mtConfirmation, [mbYes, mbCancel], 0)=mrYes then
    begin
      t:=TrackList.Items.IndexOf(TrackList.Selected);
      TrackList.Selected.Free;
      for i:=0 to TrackList.Items.Count-1 do
        TrackList.Items[i].Caption:=inttostr(i);
      for i:=Notes.Count-1 downto 0 do
      begin
        N:=Notes[i];
        if N.Track=t then
        begin
          N.Free;
          Notes.Delete(i);
        end else if N.Track>t then
        begin
          dec(N.Track);
        end;
      end;
      AddTrack.Enabled:=TrackList.Items.Count<16;
      ModTrack.Enabled:=TrackList.Items.Count>0;
      DelTrack.Enabled:=TrackList.Items.Count>0;
      TrackListClick(Sender);
    end;
  end else MessageDlg('Vous devez slectionner un track.', mtError, [mbOK], 0);
  Modified:=true;
end;

procedure TMain.ModTrackClick(Sender: TObject);
var i, n, c: integer;
    b: boolean;
begin
  if TrackList.Selected<>nil then
  begin
    TrackInfo.TrackName.Text:=TrackList.Selected.SubItems[0];
    TrackInfo.TrackChannel.Text:=TrackList.Selected.SubItems[1];
    TrackInfo.TrackPatch.ItemIndex:=strtoint(mot(1, TrackList.Selected.SubItems[2]));

    if TrackInfo.ShowModal=mrOK then
    begin
      // Vrifier que le Canal n'est pas dj utilis
      b:=true;
      c:=TrackInfo.TrackChannel.Value;
      n:=0;
      for i:=0 to TrackList.Items.Count-1 do
      begin
        if strtoint(TrackList.Items[i].SubItems[1])=c then
        begin
          n:=i;
          b:=false;
          break;
        end;
      end;
      if n=TrackList.Items.IndexOf(TrackList.Selected) then b:=true;

      // Modifier le track
      if b then
      begin
        TrackList.Selected.SubItems[0]:=TrackInfo.TrackName.Text;
        TrackList.Selected.SubItems[1]:=inttostr(TrackInfo.TrackChannel.Value);
        TrackList.Selected.SubItems[2]:=TrackInfo.TrackPatch.Text;
        MidiOut.ChangePatch(TrackInfo.TrackChannel.Value, strtoint(mot(1, TrackInfo.TrackPatch.Text)));
      end else MessageDlg('Le canal '+inttostr(c)+' est dj utilis par le track #'+inttostr(n)+'.', mtError, [mbCancel], 0);
    end;
  end else MessageDlg('Vous devez slectionner un track.', mtError, [mbOK], 0);
  Modified:=true;
end;

procedure TMain.TrackListClick(Sender: TObject);
var i, TN: integer;
begin
  Partition.Clear;
  if TrackList.Selected<>nil then
  begin
    TN:=strtoint(TrackList.Selected.Caption);
    Partition.CanPaint:=false;
    for i:=0 to Notes.Count-1 do
    begin
      if TMidiNote(Notes[i]).Track=TN then
      begin
        Partition.AddNote(TMidiNote(Notes[i]).Note, TMidiNote(Notes[i]).Pos, TMidiNote(Notes[i]).Len, integer(Notes[i]));
      end;
    end;
    Partition.CanPaint:=true;
    Partition.Paint;
  end;
end;

procedure TMain.MoveCur(Speed: integer);
begin
  StopMoveCur:=false;
  PostMessage(Handle, WM_MOVECUR, Speed, 0);
end;

procedure TMain.SpeedMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  StopMoveCur:=true;
end;

procedure TMain.BackBeginClick(Sender: TObject);
begin
  Partition.CursorPos:=0;
end;

procedure TMain.Back2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  BtnMove:=Back2;
  MoveCur(-4*MOVECURSPEED);
end;

procedure TMain.Back1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  BtnMove:=Back1;
  MoveCur(-1*MOVECURSPEED);
end;

procedure TMain.Forw1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  BtnMove:=Forw1;
  MoveCur(1*MOVECURSPEED);
end;

procedure TMain.Forw2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  BtnMove:=Forw2;
  MoveCur(4*MOVECURSPEED);
end;

procedure TMain.ForwEndClick(Sender: TObject);
var i: integer;
    N: TPartitionNote;
    lp: integer;
begin
  // Trouver la derniere position
  lp:=0;
  for i:=0 to Partition.Notes.Count-1 do
  begin
    N:=Partition.Notes[i];
    if (N.Pos+N.Len)>lp then lp:=N.Pos+N.Len;
  end;
  Partition.CursorPos:=lp*Partition.SmallestWidth;
end;

procedure TMain.DoMoveCur(var Message: TMessage);
var Next: cardinal;
begin
  Next:=GetTickCount;
  while not StopMoveCur do
  begin
    Partition.CursorPos:=Partition.CursorPos+Message.WParam;
    if Partition.CursorPos<0 then Partition.CursorPos:=0;
    Next:=Next+30;
    while GetTickCount<Next do Application.ProcessMessages;
  end;
end;

procedure TMain.PlayClick(Sender: TObject);
begin
  Play.Tag:=0;
  BackBegin.Enabled:=false;
  Back2.Enabled:=false;
  Back1.Enabled:=false;
  Play.Enabled:=false;
  StopPlay.Enabled:=true;
  PausePlay.Enabled:=true;
  Forw1.Enabled:=false;
  Forw2.Enabled:=false;
  ForwEnd.Enabled:=false;
  PostMessage(Handle, WM_PLAY, 0, 0);
end;

procedure TMain.StopPlayClick(Sender: TObject);
begin
  BackBegin.Enabled:=true;
  Back2.Enabled:=true;
  Back1.Enabled:=true;
  Play.Enabled:=true;
  StopPlay.Enabled:=true;
  PausePlay.Enabled:=false;
  Forw1.Enabled:=true;
  Forw2.Enabled:=true;
  ForwEnd.Enabled:=true;

  StopPlayNow:=true;
  Partition.CursorPos:=0;
end;

procedure TMain.PausePlayClick(Sender: TObject);
begin
  BackBegin.Enabled:=true;
  Back2.Enabled:=true;
  Back1.Enabled:=true;
  Play.Enabled:=true;
  StopPlay.Enabled:=true;
  PausePlay.Enabled:=false;
  Forw1.Enabled:=true;
  Forw2.Enabled:=true;
  ForwEnd.Enabled:=true;

  PausePlayNow:=true;
end;

procedure TMain.DoPlay(var Message: TMessage);
var i: integer;
    N: TMidiNote;
    Next: cardinal;
begin
  if Play.Tag>0 then exit;
  Play.Tag:=Partition.CursorPos div Partition.SmallestWidth;
  Next:=GetTickCount;
  StopPlayNow:=false;
  PausePlayNow:=false;
  while (not StopPlayNow) and (not PausePlayNow) do
  begin
    for i:=0 to Notes.Count-1 do
    begin
      N:=Notes[i];
      if N.Pos+N.Len=Play.Tag-1 then
      begin
        MidiOut.NoteOFF(N.Channel, N.Note);
      end;
    end;
    for i:=0 to Notes.Count-1 do
    begin
      N:=Notes[i];
      if N.Pos=Play.Tag-1 then
      begin
        MidiOut.NoteON(N.Channel, N.Note, 127);
      end;
    end;
    Play.Tag:=Play.Tag+1;
    Next:=Next+30; // 30 ms pour 1/16 de noire, soit une quadruple croche; donc 480ms pour une noire: tempo 60*1000/480 = 125
    Partition.CursorPos:=Play.Tag * Partition.SmallestWidth;
    while GetTickCount<Next do Application.ProcessMessages;
  end;
  if StopPlayNow then Partition.CursorPos:=0;
  for i:=0 to TrackList.Items.Count-1 do
    MidiOut.NotesOFF(strtoint(TrackList.Items[i].SubItems[1]));
end;

procedure TMain.PlayNote(Channel, Note: byte);
begin
  if TimerNoteOff.Enabled then TimerNoteOffTimer(Self);
  TimerNoteOff.Tag:=Note;
  TimerNoteOff.Enabled:=true;
  Partition.Tag:=Channel;
  MidiOut.NoteON(Channel, Note, 127);
end;

procedure TMain.GridLessClick(Sender: TObject);
begin
  Partition.LargePosLen:=Partition.LargePosLen div 2;
  if Partition.LargePosLen<1 then Partition.LargePosLen:=1; // quadruple croche
  Partition.VertGridLen:=Partition.LargePosLen;
  if Partition.VertGridLen<4 then Partition.VertGridLen:=4; // double croche
  GridSize.Caption:=inttostr(Partition.LargePosLen);
end;

procedure TMain.GridPlusClick(Sender: TObject);
begin
  Partition.LargePosLen:=Partition.LargePosLen * 2;
  if Partition.LargePosLen>64 then Partition.LargePosLen:=64; // ronde
  Partition.VertGridLen:=Partition.LargePosLen;
  if Partition.VertGridLen<4 then Partition.VertGridLen:=4; // double croche
  GridSize.Caption:=inttostr(Partition.LargePosLen);
end;

procedure TMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i: integer;
    N: TPartitionNote;
begin
  if (Key=46) and ModeSelect.Down then // Suppr
  begin
    for i:=Partition.Notes.Count-1 downto 0 do
    begin
      N:=Partition.Notes[i];
      if N.Sel then
      begin
        Notes.Delete(Notes.IndexOf(Pointer(N.Tag)));
        TMidiNote(N.Tag).Free;
        Partition.Notes.Delete(i);
      end;
    end;
    Partition.Paint;
  end else
  if (Key=107) then // +
  begin
    GridPlusClick(Self);
  end else
  if (Key=109) then // -
  begin
    GridLessClick(Self);
  end;// else Caption:=inttostr(Key);
end;

procedure TMain.ModeNoteClick(Sender: TObject);
begin
  Partition.ClearSel;
end;

procedure TMain.ModeDiezeClick(Sender: TObject);
begin
  Partition.ClearSel;
end;

procedure TMain.QuitterClick(Sender: TObject);
begin
  Close;
end;

procedure TMain.NouveauClick(Sender: TObject);
var res: TModalResult;
    i: integer;
begin
  res:=mrOK;
  if Modified then
  begin
    res:=MessageDlg('Voulez-vous enregistrer les modifications?', mtConfirmation, [mbYes, mbNo, mbCancel], 0);
    if res=mrYes then EnregistrerClick(Self);
  end;
  if res<>mrCancel then
  begin
    // Nouveau fichier
    Modified:=false;
    FileName:='';
    Partition.Clear;
    for i:=0 to Notes.Count-1 do TMidiNote(Notes[i]).Free;
    Notes.Clear;
    TrackList.Items.Clear;
  end;
end;

procedure TMain.OuvrirClick(Sender: TObject);
var res: TModalResult;
    Midi: TMidi;
    error: boolean;
    i, n, t: integer;
    Ev: TMidiEvent;
    timepos: cardinal;
    Note, Note2: TMidiNote;
begin
  res:=mrOK;
  if Modified then
  begin
    res:=MessageDlg('Voulez-vous enregistrer les modifications?', mtConfirmation, [mbYes, mbNo, mbCancel], 0);
    if res=mrYes then EnregistrerClick(Self);
  end;
  OpenDlg.InitialDir:=GetExePath;
  if OpenDlg.Execute and (res<>mrCancel) then
  begin
    // Ouvrir fichier
    Modified:=false;
    NouveauClick(Sender);
    FileName:=OpenDlg.FileName;

    Midi:=TMidi.Create;
    error:=false;
    try
      Midi.LoadFromFile(FileName);
    except
      error:=true;
    end;
    if error then MessageDlg('Le fichier n''a pas pu tre lu. Le format n''est pas reconnu.', mtError, [mbOK], 0) else
    begin
      // Lire Midi pour le copier dans Partition et Notes
      // Crer les Tracks
      for i:=0 to Midi.Tracks.Count-1 do
      begin
        TrackList.Items.Add;
        with TrackList.Items[TrackList.Items.Count-1] do
        begin
          Caption:=inttostr(TrackList.Items.Count-1);
          SubItems.Add('');
          SubItems.Add(inttostr(i));
          SubItems.Add(TrackInfo.TrackPatch.Items[0]);
        end;
      end;
      // Obtenir les instruments et canaux de chaque track, et ajouter les notes
      for i:=0 to Midi.Tracks.Count-1 do
      begin
        timepos:=0;
        for n:=0 to TMidiTrack(Midi.Tracks[i]).Events.Count-1 do
        begin
          Ev:=TMidiTrack(Midi.Tracks[i]).Events[n];
          timepos:=timepos+Ev.Time.CardVal;
          if not Ev.Meta then
          begin
            TrackList.Items[i].SubItems[1]:=inttostr(Ev.Channel);
            if Ev is TMidiNoteONEvent then
            begin
              Note:=TMidiNote.Create;
              Note.Note:=TMidiNoteONEvent(Ev).Note;
              Note.Pos:=timepos;
              Note.Len:=16;
              Note.Channel:=Ev.Channel;
              Note.Track:=i;
              Notes.Add(Note);
            end;
            if Ev is TMidiNoteOFFEvent then
            begin
              Note2:=nil;
              for t:=0 to Notes.Count-1 do
              begin
                Note:=Notes[t];
                if Note.Note=TMidiNoteOFFEvent(Ev).Note then Note2:=Note;
              end;
              Note2.Len:=integer(timepos)-Note2.Pos;
              if Note2.Len<1 then Note2.Len:=1;
            end;
            if Ev is TMidiChangePatchEvent then
            begin
              TrackList.Items[i].SubItems[2]:=TrackInfo.TrackPatch.Items[TMidiChangePatchEvent(Ev).Patch];
              MidiOut.ChangePatch(Ev.Channel, TMidiChangePatchEvent(Ev).Patch);
            end;
          end;
        end;
      end;
      // Slection automatique du track #0
      if TrackList.Items.Count>0 then TrackList.Items[0].Selected:=true;
      TrackListClick(Sender);
      TrackList.SetFocus;
    end;
    Midi.Free;
  end;
end;

procedure TMain.EnregistrerClick(Sender: TObject);
var Midi: TMidi;
    Track: TMidiTrack;
    Note: TMidiNote;
    Event: TMidiEvent;
    dt: vlv;
    i, n, t, last, prev: integer;
begin
  if FileName='' then SaveAsClick(Self) else
  begin
    // Enregistrer fichier
    Midi:=TMidi.Create;

    Midi.Format:=mfSync;
    Midi.TicksPerQNote:=16;
    for i:=0 to TrackList.Items.Count-1 do
    begin
      Track:=TMidiTrack.Create;
      // Instrument
      Event:=TMidiChangePatchEvent.Create;
      dt:=vlv.Create;
      dt.SetFromInt(0);
      Event.Time:=dt;
      TMidiChangePatchEvent(Event).Patch:=strtoint(mot(1, TrackList.Items[i].SubItems[2]));
      TMidiChangePatchEvent(Event).Channel:=strtoint(TrackList.Items[i].SubItems[1]);
      Track.Events.Add(Event);
      // Notes
      last:=0;
      for t:=0 to Notes.Count-1 do
      begin
        Note:=Notes[t];
        if Note.Pos+Note.Len>last then last:=Note.Pos+Note.Len;
      end;
      prev:=0;
      for n:=0 to last do
      begin
        for t:=0 to Notes.Count-1 do
        begin
          Note:=Notes[t];
          if Note.Track=i then
          begin
            if Note.Pos+Note.Len=n then
            begin
              Event:=TMidiNoteOFFEvent.Create;
              dt:=vlv.Create;
              dt.SetFromInt(n-prev);
              Event.Time:=dt;
              TMidiNoteOFFEvent(Event).Note:=Note.Note;
              TMidiNoteOFFEvent(Event).Channel:=Note.Channel;
              Track.Events.Add(Event);
              prev:=n;
            end;
            if Note.Pos=n then
            begin
              Event:=TMidiNoteONEvent.Create;
              dt:=vlv.Create;
              dt.SetFromInt(n-prev);
              Event.Time:=dt;
              TMidiNoteONEvent(Event).Note:=Note.Note;
              TMidiNoteONEvent(Event).Channel:=Note.Channel;
              TMidiNoteONEvent(Event).Velocity:=127;
              Track.Events.Add(Event);
              prev:=n;
            end;
          end;
        end;
      end;
      Midi.Tracks.Add(Track);
    end;

    Midi.SaveToFile(FileName);
    Midi.Free;
    Modified:=false;
  end;
end;

procedure TMain.SaveAsClick(Sender: TObject);
begin
  SaveDlg.InitialDir:=GetExePath;
  if SaveDlg.Execute then
  begin
    FileName:=SaveDlg.FileName;
    EnregistrerClick(Self);
  end;
end;

procedure TMain.DeasmClick(Sender: TObject);
var s: string;
begin
  OpenDlg.InitialDir:=GetExePath;
  if OpenDlg.Execute then
  begin
    DisassMidi(OpenDlg.FileName, OpenDlg.FileName+'.txt');
    s:=OpenDlg.FileName+'.txt';
    ShellExecute(Handle, 'open', PChar(s), '', '', SW_SHOWNORMAL);
  end;
end;

end.
